/*
 * Copyright (C) 2012   Pierre Habouzit <pierre.habouzit@intersec.com>
 * Copyright (C) 2012   Intersec SAS
 *
 * This file implements the Linux Pthread Workqueue Regulator, and is part
 * of the linux kernel.
 *
 * The Linux Kernel is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License version 2 as published by
 * the Free Software Foundation.
 *
 * The Linux Kernel is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public
 * License for more details.
 *
 * You should have received a copy of the GNU General Public License version 2
 * along with The Linux Kernel.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef _LINUX_PWQR_H
#define _LINUX_PWQR_H
#include <linux/ioctl.h>

#ifdef __KERNEL__
#include <linux/fcntl.h>
#else
#include <fcntl.h>
#endif

#define PWQR_DEVICE_NAME	"pwq"
#define PWQR_IO			'}'

struct pwqr_ioc_wait {
	int	pwqr_ticket;
	void   *pwqr_uaddr;
};

#define PWQR_CTL_GET_CONC	_IO (PWQR_IO, 0)
#define PWQR_CTL_SET_CONC	_IO (PWQR_IO, 1)
#define PWQR_CTL_REGISTER	_IO (PWQR_IO, 2)
#define PWQR_CTL_UNREGISTER	_IO (PWQR_IO, 3)
#define PWQR_CTL_WAKE		_IO (PWQR_IO, 4)
#define PWQR_CTL_WAKE_OC	_IO (PWQR_IO, 5)
#define PWQR_CTL_WAIT		_IOW(PWQR_IO, 6, struct pwqr_ioc_wait)
#define PWQR_CTL_PARK		_IO (PWQR_IO, 7)

#define PWQR_FL_NONBLOCK	O_NONBLOCK
#define PWQR_FL_CLOEXEC		O_CLOEXEC
#define PWQR_FL__FCTNL_FLAGS	(PWQR_FL_NONBLOCK | PWQR_FL_CLOEXEC)
#define PWQR_FL__SET		(PWQR_FL__FCTNL_FLAGS)

#endif
